from mpi4py import mpi
import numpy

class mpi_worker:
    def __init__(self,worker_num):
        self.comm = mpi.COMM_WORLD
        self.rank = mpi.Get_rank()
        self.worker_num=worker_num()
        
    def loadGraph(self,path):
        self.graph=[]
        
    def get_attr(self,node_list):
        sample_info={}
        broadcast_info={}
        for rank in range(self.worker_num):
            sample_info[rank]=[]
            broadcast_info[rank]=[]
        
        node_feature={}
        for root in node_list:
            part=self.graph.get_nodepart(root[0])
            if(part==self.rank):
                for nid in root[0,:]:
                    part0=self.graph.get_nodepart(nid)
                    sample_info[part0].append(nid)
                    
            else:
                for nid in root[0,:]:
                    part0=self.graph.get_nodepart(nid)
                    if(part0==self.rank):
                        broadcast_info[part0].append(self.graph.get_nodeattr(nid))
                    
        for rank in range(self.worker_num): 
            data=self.comm.bcast(broadcast_info,rank)
            if(sample_info[rank]):
                for ndata in data:
                    nid=ndata[0]
                    if(nid in sample_info):
                        node_feature[nid]=ndata[1,:]
                    
                